var SmartTables;

SmartTables = class SmartTables {
  static processTable(currentTable, currentPosition) {
    
    var substituteCells = function(currentCellContents, possibleCells) {
      for (var i=0; i < possibleCells.length; i++){
        var strUpper = possibleCells[i].getAttribute("Class").toUpperCase()
        var strLower = possibleCells[i].getAttribute("Class").toLowerCase()
        strUpper = strUpper.slice(0, -8);
        strLower = strLower.slice(0, -8);
        var possibleCellUpper = new RegExp("\\b" + strUpper + "\\b",'g')
        var possibleCellLower = new RegExp("\\b" + strLower + "\\b",'g')
        var replacementCellString = possibleCells[i].innerHTML


        // Remove syntax from replacement string if it exists
        if (replacementCellString.startsWith("=(") && replacementCellString.endsWith(")")){
            replacementCellString = replacementCellString.substring(2,replacementCellString.length -1)
        }

        // Enclose replacement in parens
        var replacementContent = "(" + replacementCellString + ")"
        currentCellContents = currentCellContents.replace(possibleCellUpper,replacementContent)
        currentCellContents = currentCellContents.replace(possibleCellLower,replacementContent)
      }
      return(currentCellContents)
    }
    
    var getTableID = function(currentTable, currentPosition) {
      var captionExists = currentTable.getElementsByTagName("caption")[0]
      if (captionExists) {
        var tableID = captionExists.innerHTML
        tableID = tableID.replace(/\s+/g, '-').toLowerCase();
      } else {
        var tableID = "T" + currentPosition 
      }
      return(tableID)
    }
    
    
    var writeRowIDs = function(currentRowElements, currentRow) {
      var possibleColumns = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
      for (var i = 0; i < currentRowElements.length; i++) {
        var currentColumn = possibleColumns.charAt(i);
        var cellID = tableID + "-" + currentColumn + currentRow
        var cellClass = currentColumn + currentRow + " tooltip"
        currentRowElements[i].setAttribute("Class",cellClass)
        currentRowElements[i].setAttribute("Id",cellID)
      }
    }
    
    var totalCellsAbove = function(cellID, currentTable) {
      var cleanID = cellID.replace(tableID, "");
      var column = cleanID.match(/[a-zA-Z]+/)[0]
      var row = cleanID.match(/(?:\d*\.)?\d+/)[0]
      var columnTotal = 0
      try {
        for (var i = 1; i < parseInt(row); i++){
          var currentCellID = column + i.toString()
          var currentCellContents = currentTable.getElementsByClassName(currentCellID)[0].innerHTML

          // Add current cell to our running tally
          if (currentCellContents){columnTotal += numeral(currentCellContents).value()}
        }
      }
      catch(err) {
        console.log(err)
        columnTotal = "<span style='color: red'>#ERR</span>"
      }
      return columnTotal
    }
    
    var currentRow = 0
    var tableCells = currentTable.querySelectorAll("th, td")

    // Assign Table an ID
    var tableID = getTableID(currentTable, currentPosition)
    currentTable.setAttribute("Id",tableID)
    
    // **Assign IDs**
    // ...to table headers
    var currentTableHeadRows = currentTable.getElementsByTagName("thead")[0].getElementsByTagName("tr")
    for (var j=0; j < currentTableHeadRows.length; j++){
        var currentTableHeaderList = currentTableHeadRows[j].getElementsByTagName("th")
        writeRowIDs(currentTableHeaderList, currentRow)
        currentRow++
    }

    // ...to table body rows
    var currentTableBodyRows = currentTable.getElementsByTagName("tbody")[0].getElementsByTagName("tr")
    for (var j=0; j < currentTableBodyRows.length; j++){
      var currentTableRows = currentTableBodyRows[j].getElementsByTagName("td")
      writeRowIDs(currentTableRows, currentRow)
      currentRow++
    }

    // **Substitutions**
    for (var j=0; j < tableCells.length; j++){
      var currentCellData = tableCells[j].innerHTML
      if ((currentCellData.startsWith("=(") && currentCellData.endsWith(")")) && (currentCellData.toString().toUpperCase() != "=(TOTAL)")) {
        try {
          var newCellContents = substituteCells(currentCellData,tableCells)
          tableCells[j].innerHTML = newCellContents
        }
        catch(err) {
          console.log(err)
          tableCells[j].innerHTML = "<span style='color: red'>#ERR</span>"
        }
      }
    }

    // **Calculations**
    for (var j=0; j < tableCells.length; j++) {
      var currentCellData = tableCells[j].innerHTML
      if ((currentCellData.startsWith("=(") && currentCellData.endsWith(")")) && (currentCellData.toString().toUpperCase() != "=(TOTAL)")) {
        try {
          var mathToSolve = currentCellData.substring(2,currentCellData.length -1)
          tableCells[j].innerHTML = math.format(math.evaluate(mathToSolve), {notation: 'fixed'})
        }
        catch(err) {
          console.log(err)
          console.log(tableCells[j].innerHTML)
          tableCells[j].innerHTML = "<span style='color: red'>#ERR</span>"
        }
      }
      else if (currentCellData.toString().toUpperCase() == "=(TOTAL)"){
          var currentCellID = tableCells[j].getAttribute("Class").slice(0, -8)
          tableCells[j].innerHTML = totalCellsAbove(currentCellID, currentTable)
      }
    }
  }
  
};
